

#Run
#/usr/local/R-2.9.2_64bit/bin/R --no-save --slave --args MaxNode node <  /ifs/hardi/Neda/SCRIPTS/MULTI_GenoPheno/run_emmaX_ROI.R

cmdargs = commandArgs(trailingOnly=T);


table=cmdargs[1];  #req columns: familyID, subjectID, zygosity;  put zygosity info here code as 0,1,2
imgpaths=cmdargs[2]
Outputdirectory=cmdargs[3];

grp=cmdargs[4]

SNP=cmdargs[5]

Ncov=as.numeric(cmdargs[6]);
covariates=cmdargs[7] #semicolon separated list of table headers cov1; cov2; cov3
Nfilters=as.numeric(cmdargs[8]);
filters=cmdargs[9];

system(paste('mkdir -p', Outputdirectory))

Outputdirectory = paste(Outputdirectory,'/',sep='');
OutputdirectoryEX = paste(Outputdirectory,'/vRFX/',sep='');
dir.create(OutputdirectoryEX);


## the table with all the info
Table<-read.table(table,sep="\t",header=T,blank.lines.skip = TRUE)
columnnames = colnames(Table);

SNPfile=paste(Outputdirectory,'/',SNP,'_1kg.txt',sep="")
SNPinfo<-read.table(SNPfile,sep=" ",header=FALSE,blank.lines.skip = TRUE)

print(SNPinfo[,2])
if ( grp=="none" || grp=="0" || grp =="no") {
    DesignMatrix<-data.frame(familyID=Table$subjectID, subjectID=Table$subjectID, imgpaths=Table[,which(columnnames==imgpaths)])
    } else {
        DesignMatrix<-data.frame(familyID=Table$familyID, subjectID=Table$subjectID,zygosity=Table$zygosity, imgpaths=Table[,which(columnnames==imgpaths)],group=Table$subjectID)
    }

    nsub=length(as.vector(Table$subjectID))
    print(nsub)



## read and parse covariates if they exist
## add to design Matrix
if (Ncov > 0) {
    cov<-as.matrix(0,nrow=nsub,ncol=Ncov)
    parsedCov=parse(text=covariates)

    for (nc in 1:Ncov) {
        covName<-as.character(parsedCov[nc])
        print(covName)
        origcolnames = colnames(DesignMatrix);
        DesignMatrix[,length(DesignMatrix)+1] = Table[,which(columnnames==covName)]
        colnames(DesignMatrix) = c(origcolnames,covName);
    }
    print(paste("done adding covariates",parsedCov))
}


if (Nfilters > 0) {
    parsedFilt=parse(text=filters)

    for (nf in 1:Nfilters) {
        filtName<-as.character(parsedFilt[nf])
        print(filtName)
        origcolnames = colnames(DesignMatrix);
        DesignMatrix[,length(DesignMatrix)+1] = Table[,which(columnnames==filtName)]
        colnames(DesignMatrix) = c(origcolnames,filtName);
    }
    print(paste("done adding filter",parsedFilt))
}
############
#### add in SNP
origcolnames = colnames(DesignMatrix);
matchind = match(DesignMatrix$subjectID,SNPinfo[,1]);
DesignMatrix[,length(DesignMatrix)+1] = SNPinfo[,2][matchind];

colnames(DesignMatrix) = c(origcolnames,SNP);
print(colnames(DesignMatrix))
print(DesignMatrix)
##get rid of all rows with NAs in them
i=which(apply(DesignMatrix,1,function(x)any(is.na(x))));
##get rid of all rows with NAs in them
if (length(i) >0 ){
    DesignMatrix<-DesignMatrix[-which(apply(DesignMatrix,1,function(x)any(is.na(x)))),]
}


### remove duplicates
dups<-duplicated(DesignMatrix$subjectID)
Ldups<-length(which(dups,"TRUE"))
cat('    There are',Ldups,'duplicate images that have been removed')

if (Ldups > 0){
    DesignMatrix<-DesignMatrix[-which(dups,"TRUE"),]
}

origcolnames = colnames(DesignMatrix);
pheno=as.vector(DesignMatrix[,which(origcolnames==SNP)])


## get some variables
nsub=length(as.vector(DesignMatrix$subjectID)) 

print(nsub)

write.table(DesignMatrix[,1:2],paste(Outputdirectory,'/subjectlist.txt',sep=''),sep="\t",row.names=F,col.names=F);
subjectlist= paste(Outputdirectory,'/subjectlist.txt',sep='');

if ( grp=="none" || grp=="0" || grp =="no") {
    imgpaths=DesignMatrix$imgpaths
    group=NULL

    } else {
        imgpaths=DesignMatrix$imgpaths
        group=DesignMatrix$group
        nsub=length(as.vector(DesignMatrix$subjectID)) 

#######################################################
#Create a Kinship Matrix
        numsubjects = length(DesignMatrix$subjectID);
        K = diag(numsubjects);
        #Loop over the relationship of each subject to every other subject
        for (i in 1:numsubjects) {
            for (j in 1:numsubjects) {
            #determine if in the same family
            if (DesignMatrix$familyID[i]==DesignMatrix$familyID[j]) {
            #if the same person make sure the relationship is 1
            if (DesignMatrix$subjectID[i] == DesignMatrix$subjectID[j]) {
                K[i,j] = 1;
            }
            #if MZ twins, make sure relationship is 1
            else if ((DesignMatrix$zygosity[i]==1) && (DesignMatrix$zygosity[j]==1)){
                K[i,j] = 1;
            }
            #Must be a sib if related and not MZ
            else {
                K[i,j] = 0.5;
                }
            }
        }
    }
    write.table(K,paste(Outputdirectory,'/KinshipMatrix.txt',sep=''),sep="\t",row.names=FALSE,col.names=FALSE);
}
#
#######################################################

if (Ncov >0){
    covariatesforRFX = matrix(1,nrow=nsub,ncol=Ncov);

}

pheno_covariatesforRFX = matrix(1,nrow=nsub,ncol=Ncov+1);
colnames_pheno_cov = colnames(pheno_covariatesforRFX);
pheno_covariatesforRFX[,1]=pheno;
colnames_pheno_cov[1]=SNP;

origcolnames = colnames(DesignMatrix);
print(origcolnames)
if (Ncov > 0) {
    parsedCov=parse(text=covariates)
    cat('    There are',Ncov,'covariates\n');
    for (covariate in 1:Ncov) {
        covName=as.character(parsedCov[covariate])
        print(covName)
        covariatesforRFX[,covariate] = DesignMatrix[,which(origcolnames==covName)];
        pheno_covariatesforRFX[,covariate+1] = DesignMatrix[,which(origcolnames==covName)];
        colnames_pheno_cov[covariate+1]=covName;
    }
    write.table(covariatesforRFX,paste(Outputdirectory,'/covars.txt',sep=''),sep="\t",row.names=F,col.names=F);
    } else {
        cat('    There are no covariates\n');
    }
    colnames(pheno_covariatesforRFX)=colnames_pheno_cov;
    write.table(pheno_covariatesforRFX,paste(Outputdirectory,'/pheno_covars.txt',sep=''),sep="\t",row.names=TRUE,col.names=TRUE);

    columnnames = colnames(DesignMatrix);
#Find out how many subjects are in the file
numsubjects = length(DesignMatrix$subjectID);
cat('    There are',numsubjects,'subjects in the Design Matrix\n');

write.table(DesignMatrix,paste(Outputdirectory,'/DesignMatrix.txt',sep=''),sep="\t",row.names=F,col.names=TRUE);
#########################################################

system(paste('rm',paste(Outputdirectory,'/',SNP,"_information_file.txt",sep="")));
zz <- file(paste(Outputdirectory,'/',SNP,"_information_file.txt",sep=""),"w")
writeLines(paste("   Table file is:",table),con=zz,sep="\n")
writeLines(paste("   grouping factor is:",grp),con=zz,sep="\n")
writeLines(paste("   SNP is: ",SNP),con=zz,sep="\n")
writeLines(paste("   phenotype median:",median(pheno_covariatesforRFX[,1])),con=zz,sep="\n")
writeLines(paste('   There are',numsubjects,'subjects in the analysis'),con=zz,sep="\n")
writeLines(paste("   the image paths are: "),con=zz,sep="\n")
writeLines(paste("              ",imgpaths),con=zz,sep="\n")



if (Ncov > 0){
    for (n in 1: Ncov){
        parsedCov=parse(text=covariates)
        writeLines(paste("   Covariate:",parsedCov[n]),con=zz,sep="\n")
        }
    }
        if (Nfilters > 0){
            for (n in 1: Nfilters){
                filtName<-as.character(parsedFilt[n])
                writeLines(paste("   Filter:",parsedFilt[n]),con=zz,sep="\n")
                }
            }
close(zz)


